import 'package:luhn/luhn.dart';
import 'package:test/test.dart';

void main() {
  var testVector = {
    '12345': 5,
    '901235414': 9,
    '63522141777475': 4,
    '11111111': 8,
    '00001': 8,
    '00000000': 0,
  };
  group('Test that the algorithm is correctly implemented', () {
    test('It computes the test digit correctly', () {
      for (var key in testVector.keys) {
        var digit = Luhn.computeCheckDigit(key);
        expect(digit, testVector[key]);
      }
    });
    test('It creates valid codes', () {
      for (var key in testVector.keys) {
        var valid = Luhn.computeAndAppendCheckDigit(key);
        expect(valid, '$key${testVector[key]}');
      }
    });
    test('It creates valid codes', () {
      for (var key in testVector.keys) {
        var valid = Luhn.isValidNumber('$key${testVector[key]}');
        expect(valid, true);
      }
    });
  });
}
